<?

 /*****************************************************************************
 * Filename: include/plugins/pager/modules/markers.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");
 require_once($_path["include"]."mutilate.php");
 require_once($_path["format"]."xml.php");

 class Plugin_Module_pager_markers extends Module
 {
  function __construct(&$data)
  {
   global $_path;

   parent::__construct($data);

   $this->data->title="Page template markers";

   $this->data->addField("title", "text", "all", "title", 1, 255, false, "Title");

   $this->data->addField("templatenr", "nr", "all", "", 1, false, 0, "Template");
   $this->data->addReference("templatenr", "pager_templates", "nr", "*:1");
   $this->data->addField("marker", "text", "all", "", 1, 255, false, "Marker");

   $this->data->addField("placing", "enum", "all", false, false, false, "body", "Marker place");
   $this->data->enumOptions("placing", "header", "body", "footer");

   $this->data->addField("clean", "boolean", "all", false, false, false, true, "Clean up marker before adding content");
   $this->data->addField("small", "boolean", "all", false, false, false, false, "Display small/narrow in backend");
   $this->data->addField("ordernr", "nr", "sql", "order", false, false, 0, "Order number", "Leave: 0 for automatic number");

   $this->data->defaultFields();

   $this->data->group("Marker", "clean", "small");
   $this->data->sortOrder("placing", "ordernr", "title");
  }

  function postInit(){return $this->customizeFields();}
  function copyPostGet(){return $this->customizeFields();}
  function editPostGet(){return $this->customizeFields();}
  function movePostGet(){return $this->customizeFields();}
  function deletePostGet(){return $this->customizeFields();}

  function customizeFields()
  {
   global $_path;

   if($this->data->getValue("templatenr"))
   {
    $d=Data::cache("pager_templates", "view", "item");
    $d->setShowFields("template");
    $d->clearValues();

    $d->setValue("nr", $this->data->getValue("templatenr"));

    if($d->get()&&$d->next())
    {
     $xml=new Format_XML();
     if($xml->read($_path["project"]["templates"].$d->v["template"]))
     {
      $ids=Array("" => "");
      $mapping=Array();
      for($c=0;$c<$xml->vmax;$c++)
      {
       if($id=$xml->getAttribute($c, "id"))
       {
        $path=$xml->getPath($c);
        $tmp=$path;

        //replace first part of path with earlier ids
        foreach(array_reverse($mapping) as $from => $to) //start looking from last entry to ensure full section is replaced
        {
         if(strstr($tmp, $from))
         {
          $tmp=str_replace($from, $to, $tmp);
          break;
         }
        }

        //remove [0], replace last [2], add #id
        $tmp=str_replace("[0]", "", $tmp);
        $tmp=preg_replace("/\[\d+\]$/", "", $tmp);
        $tmp.="#".$id;

        $mapping[$path]=$tmp; //store translated path
        $ids[$tmp]=Mutilate::changeCaseS($id, "first"); //add to option list
       }
      }

      $this->data->listOptions("marker", $ids);
     }
    }
   }

   return true;
  }
 }
?>
