<?

 /*****************************************************************************
 * Filename: include/plugins/pager/modules/pluginConfigs.php
 *
 * This file is part of the JAS project.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The JAS project is free software under the terms of the
 * GNU Lesser General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the project or http://jas.junerules.com/license/
 *****************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_pager_pluginConfigs extends Module
 {
  function __construct(&$data)
  {
   parent::__construct($data);

   if($this->data->module!="pluginConfigs")
    $this->extend("pluginConfigs");

   $this->data->title="Pager plugin configuration";

   $this->data->addField("simple", "boolean", "all", false, false, false, true, "Simple mode");
   $this->data->addField("benchmark", "boolean", "all", false, false, false, false, "Show benchmark results");


   $this->data->addField("rootpagenr", "nr", "all", "reload", 1, false, 0, "Root page");
   $this->data->addReference("rootpagenr", "categories", "nr", "*:1");

   $this->data->addField("startpagenr", "nr", "all", "reload", 0, false, 0, "Start page");
   $this->data->addReference("startpagenr", "categories", "nr", "*:0");

   $this->data->addField("errorTemplate", "localfile", "all", "recursive", false, 255, "error.html", "Alternative error page template");

   $this->data->group("Pages", "rootpagenr", "startpagenr", "contentTemplate", "errorTemplate");
  }

  function postInit()
  {
   global $_path;

   $this->data->setFileDir("errorTemplate", $_path["project"]["templates"]);
   $this->data->setFileExtensions("errorTemplate", "html", "htm");

   if($this->data->action=="add")
   {
    //set default root page (first category with pager_pluginConfigs)
    if($this->data->getValueType("rootpagenr")=="default"||$this->data->getValueType("catnr")=="default")
    {
     $d=Data::cache("categories", "view", "all");
     $d->clearValues();

     $d->setShowFields("nr");
     $d->setValue("module", "pager_pluginConfigs");
     $d->setOperator("module", "like");

     if($d->get()&&$d->next())
     {
      if($this->data->getValueType("rootpagenr")=="default")
       $this->data->setValue("rootpagenr", $d->v["nr"]);

      if($this->data->getValueType("catnr")=="default")
       $this->data->setValue("catnr", $d->v["nr"]);
     }
    }

    //set default home page (first category with pager_content)
    if(!$this->data->getValue("startpagenr"))
    {
     $d=Data::cache("pager_categories", "view", "all");
     $d->clearValues();

     $d->setShowFields("nr");
     $d->setValue("module", "pager_content");
     $d->setOperator("module", "like");

     if($d->get()&&$d->next())
      $this->data->setValue("startpagenr", $d->v["nr"]);
    }
   }

   return true;
  }
 }
?>
